﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MapSuiteGeocoder;
using System.IO;

namespace ThinkGeoGIS_PoC.Forms
{
    public partial class TIGERData : Form
    {

        #region Private Instance Fields

        private string mapbase = Path.Combine(Environment.CurrentDirectory, "TIGERData");

        #endregion

        public TIGERData()
        {
            InitializeComponent();
            this.Load += new EventHandler(TIGERData_Load);
        }

        #region Events

        //protected void lstResult_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    MatchItem matchItem = ((ListItem)lstResult.SelectedItem).MatchItem;

        //    // Set the marker location to the address selected
        //    LayerOverlay markerOverlay = wfmapMap.Overlays["MarkerOverlay"] as LayerOverlay;
        //    MarkerLayer markerLayer = markerOverlay.Layers["MarkerLayer"] as MarkerLayer;
        //    markerLayer.MarkerLocation = new PointShape(matchItem.MatchPairs["CentroidPoint"]);

        //    // Set the extent around the address and refresh the map
        //    wfmapMap.CurrentExtent = new RectangleShape(matchItem.MatchPairs["BoundingBox"]);
        //    wfmapMap.Refresh();
        //}

        //protected void btnSearch_Click(object sender, EventArgs e)
        //{
        //    // Get the path to the data files and create the Geocoder
        //    string dataPath = Path.Combine(mapbase, "ChicagoData");
        //    UsaGeocoder usaGeocoder = new UsaGeocoder(dataPath, MatchStatus.FuzzyMatch);

        //    // Open the geocoder, get any matches and close it
        //    MatchResult matchResult;
        //    try
        //    {
        //        usaGeocoder.Open();
        //        matchResult = usaGeocoder.Match(txtAddress.Text);
        //    }
        //    finally
        //    {
        //        usaGeocoder.Close();
        //    }

        //    PopulateAddressResultList(matchResult);
        //}

        //protected void btnZoomOut_Click(object sender, EventArgs e)
        //{
        //    wfmapMap.ZoomOut(20);
        //    wfmapMap.Refresh();
        //}

        //protected void btnZoomIn_Click(object sender, EventArgs e)
        //{
        //    wfmapMap.ZoomIn(60);
        //    wfmapMap.Refresh();
        //}

        protected void TIGERData_Load(object sender, EventArgs e)
        {
            //lblX.Text = lblY.Text = string.Empty;

            mapMap.MapUnit = GeographyUnit.DecimalDegree;

            //mapMap.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            InMemoryFeatureLayer pointLayer = new InMemoryFeatureLayer();
            pointLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Bitmap;
            pointLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.Image = new GeoImage(Path.Combine(mapbase, "Semi Truck.png"));
            pointLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            ShapeFileFeatureLayer countiesLayer = new ShapeFileFeatureLayer(mapbase + "\\County\\tl_2009_18_county.shp");
            ShapeFileFeatureLayer.BuildIndexFile(mapbase + "\\County\\tl_2009_18_county.shp");
            LayerOverlay mapOverlays = new LayerOverlay();
            mapOverlays.Layers.Add("Counties", countiesLayer);
            mapMap.CurrentExtent = new RectangleShape(-88.3330001640625, 42.5966329101563, -86.9157638359375, 41.1629170898438);

            //WorldMapKitWmsDesktopOverlay wmkOverlay = new WorldMapKitWmsDesktopOverlay();
            //mapMap.Overlays.Add("WorldMapKitWmsOverlay", wmkOverlay);

            //LayerOverlay pointOverlay = new LayerOverlay();
            //pointOverlay.Layers.Add("PointLayer", pointLayer);
            //mapMap.Overlays.Add("PointOverlay", pointOverlay);

            // Marker Overlay
            //LayerOverlay markerOverlay = new LayerOverlay();
            //mapMap.Overlays.Add("MarkerOverlay", markerOverlay);

            // Marker layer
            //MarkerLayer markerLayer = new MarkerLayer();
            //markerOverlay.Layers.Add("MarkerLayer", markerLayer);

            ScaleLineAdornmentLayer scaleLine = new ScaleLineAdornmentLayer();
            scaleLine.Location = AdornmentLocation.LowerLeft;
            scaleLine.XOffsetInPixel = 25f;
            scaleLine.YOffsetInPixel = -25f;

            mapMap.Overlays.Add(mapOverlays);
            mapMap.AdornmentOverlay.Layers.Add("ScaleLineAdornmentLayer", scaleLine);

            //// ------------------------------------------
            //// Test to home in on zip on load
            //bool FilterWorked = false;
            //if (!String.IsNullOrEmpty(CountyFilter))
            //{
            //    // Get the path to the data files and create the Geocoder
            //    string dataPath = Path.Combine(mapbase, "ChicagoData");
            //    UsaGeocoder usaGeocoder = new UsaGeocoder(dataPath, MatchStatus.FuzzyMatch);

            //    // Open the geocoder, get any matches and close it
            //    MatchResult matchResult;
            //    try
            //    {
            //        usaGeocoder.Open();
            //        matchResult = usaGeocoder.Match(String.Format("{0} county IN", CountyFilter));
            //    }
            //    finally
            //    {
            //        usaGeocoder.Close();
            //    }
            //    if (matchResult.MatchItems.Count > 0)
            //    {
            //        FilterWorked = true;
            //        MatchItem matchItem = matchResult.MatchItems[0];
            //        mapMap.CurrentExtent = new RectangleShape(matchItem.MatchPairs["BoundingBox"]);
            //    }
            //}
            //if (!FilterWorked)
            //    mapMap.CurrentExtent = new RectangleShape(-88.3330001640625, 42.5966329101563, -86.9157638359375, 41.1629170898438);

            //// ------------------------------------------



            //mapMap.MapClick += new EventHandler<MapClickWinformsMapEventArgs>(wfmapMap_MapClick);

            mapMap.Refresh();
        }

        //protected void wfmapMap_MapClick(object sender, MapClickWinformsMapEventArgs e)
        //{
        //    //MessageBox.Show(string.Format("X:{0}\nY:{1}", e.WorldX.ToString("N4"), e.WorldY.ToString("N4")));
        //    lblX.Text = string.Format("Lon: {0}", e.WorldX.ToString("N4"));
        //    lblY.Text = string.Format("Lat: {0}", e.WorldY.ToString("N4"));

        //    Feature SelectedPoint = new Feature(e.WorldX, e.WorldY, "Point1");

        //    InMemoryFeatureLayer pointLayer = (InMemoryFeatureLayer)wfmapMap.FindFeatureLayer("PointLayer");
        //    if (!pointLayer.InternalFeatures.Contains("Point1"))
        //    {
        //        pointLayer.InternalFeatures.Add("Point1", SelectedPoint);
        //    }
        //    else
        //    {
        //        pointLayer.InternalFeatures.Remove("Point1");
        //        pointLayer.InternalFeatures.Add("Point1", SelectedPoint);
        //    }

        //    // Reverse Geocode Location
        //    UsaGeocoder usaGeocoder = new UsaGeocoder(Path.Combine(mapbase, "ChicagoData"));

        //    MatchResult matchResult = new MatchResult();
        //    try
        //    {
        //        usaGeocoder.Open();
        //        matchResult = usaGeocoder.Match(String.Format("{0} {1}", e.WorldX.ToString(), e.WorldY.ToString()));
        //    }
        //    catch (Exception ex)
        //    {
        //        MessageBox.Show(String.Format("RevGeocode error:\n{0}", ex.ToString()));
        //    }
        //    finally
        //    {
        //        usaGeocoder.Close();
        //    }

        //    if (matchResult.MatchItems.Count > 0)
        //    {
        //        MatchItem matchItem = matchResult.MatchItems[0];
        //        txtReverseAddress.Text =
        //            String.Format("{0} {1} {2} {3}, {4}, {5} County, {6}, {7}",
        //            matchItem.MatchPairs["HouseNumber"],
        //            matchItem.MatchPairs["PrefixDirectional"],
        //            matchItem.MatchPairs["Street"],
        //            matchItem.MatchPairs["StreetType"],
        //            matchItem.MatchPairs["City"],
        //            matchItem.MatchPairs["County"],
        //            matchItem.MatchPairs["State"],
        //            matchItem.MatchPairs["Zip"]);
        //    }
        //    else
        //    {
        //        txtReverseAddress.Text = "Could not find.";
        //    }

        //    wfmapMap.Refresh(wfmapMap.Overlays["PointOverlay"]);

        //}

        #endregion

        #region Private Instance Methods

        //private void PopulateAddressResultList(MatchResult matchResult)
        //{
        //    // Clear the results
        //    lstResult.Items.Clear();
        //    //dataGridViewDetail.Rows.Clear();

        //    // Load the matching items into the grid
        //    foreach (MatchItem matchItem in matchResult.MatchItems)
        //    {
        //        if (matchItem.MatchPairs.ContainsKey("Street"))
        //        {
        //            lstResult.Items.Add(new ListItem(matchItem, new string[] { "Street", "Zip", "State" }));
        //        }
        //        else if (matchItem.MatchPairs.ContainsKey("Zip"))
        //        {
        //            lstResult.Items.Add(new ListItem(matchItem, new string[] { "Zip", "State" }));
        //        }
        //        else if (matchItem.MatchPairs.ContainsKey("City"))
        //        {
        //            lstResult.Items.Add(new ListItem(matchItem, new string[] { "City", "State" }));
        //        }
        //        else if (matchItem.MatchPairs.ContainsKey("County"))
        //        {
        //            lstResult.Items.Add(new ListItem(matchItem, new string[] { "County", "State" }));
        //        }
        //        else if (matchItem.MatchPairs.ContainsKey("State"))
        //        {
        //            lstResult.Items.Add(new ListItem(matchItem, new string[] { "State" }));
        //        }
        //    }

        //    // If we find addresses then select the first one to zoom in, if not then say we did not find any
        //    if (lstResult.Items.Count > 0)
        //    {
        //        lstResult.SelectedIndex = 0;
        //    }
        //    else
        //    {
        //        MessageBox.Show("Address can not be found!", "How Do I Samples", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
        //    }
        //}

        #endregion

        #region Public Instance Properties

        public string CountyFilter { get; set; }

        #endregion
    }
}
